diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/examples/tcp/tcp-pacing.cc ns-3.32/examples/tcp/tcp-pacing.cc
--- ns-3.31/examples/tcp/tcp-pacing.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/examples/tcp/tcp-pacing.cc	2020-10-06 15:35:43.000000000 -0700
@@ -1,5 +1,7 @@
 /* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
 /*
+ * Copyright (c) 2020 NITK Surathkal
+ *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation;
@@ -12,20 +14,73 @@
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Vivek Jain <jain.vivek.anand@gmail.com>
+ *          Deepak Kumaraswamy <deepakkavoor99@gmail.com>
  */
 
-// Network topology
+// The following network topology is used in this example, and is taken from
+// Figure 2 of https://homes.cs.washington.edu/~tom/pubs/pacing.pdf
+//
+//    n0                          n4
+//    |                           |
+//    |(4x Mbps, 5ms)             |(4x Mbps, 5ms)
+//    |                           |
+//    |                           |
+//    |      (x Mbps, 40ms)       |
+//    n2 ------------------------ n3
+//    |                           |
+//    |                           |
+//    |(4x Mbps, 5ms)             |(4x Mbps, 5ms)
+//    |                           |
+//    n1                          n5
+//
 //
-//       n0 ----------- n1
-//            40 Gbps
-//            0.01 ms
-
-// This programs illustrates how TCP pacing can be used and how user can set
-// pacing rate. The program gives information about each flow like transmitted
-// and received bytes (packets) and throughput of that flow. Currently, it is 
-// using TCP NewReno but in future after having congestion control algorithms 
-// which can change pacing rate can be used.
 
+// This example illustrates how TCP pacing can be enabled on a socket.
+// Two long-running TCP flows are instantiated at nodes n0 and n1 to
+// send data over a bottleneck link (n2->n3) to sink nodes n4 and n5.
+// At the end of the simulation, the IP-level flow monitor tool will
+// print out summary statistics of the flows.  The flow monitor detects
+// four flows, but that is because the flow records are unidirectional;
+// the latter two flows reported are actually ack streams.
+//
+// At the end of this simulation, data files are also generated
+// that track changes in Congestion Window, Slow Start threshold and
+// TCP pacing rate for the first flow (n0). Additionally, a data file
+// that contains information about packet transmission and reception times
+// (collected through TxTrace and RxTrace respectively) is also produced.
+// This transmission and reception (ack) trace is the most direct way to
+// observe the effects of pacing.  All the above information is traced
+// just for the single node n0.
+//
+// A small amount of randomness is introduced to the program to control
+// the start time of the flows.
+//
+// This example has pacing enabled by default, which means that TCP
+// does not send packets back-to-back, but instead paces them out over
+// an RTT. The size of initial congestion window is set to 10, and pacing
+// of the initial window is enabled. The available command-line options and
+// their default values can be observed in the usual way by running the
+// program to print the help info; i.e.: ./waf --run 'tcp-pacing --PrintHelp'
+//
+// When pacing is disabled, TCP sends eligible packets back-to-back. The
+// differences in behaviour when pacing is disabled can be observed from the
+// packet transmission data file. For instance, one can observe that
+// packets in the initial window are sent one after the other simultaneously,
+// without any inter-packet gaps. Another instance is when n0 receives a
+// packet in the form of an acknowledgement, and sends out data packets without
+// pacing them.
+//
+// Although this example serves as a useful demonstration of how pacing could
+// be enabled/disabled in ns-3 TCP congestion controls, we could not observe
+// significant improvements in throughput for the above topology when pacing
+// was enabled. In future, one could try and incorporate models such as
+// TCP Prague and ACK-filtering, which may show a stronger performance
+// impact for TCP pacing.
+
+#include <iomanip>
+#include <iostream>
 #include <string>
 #include <fstream>
 #include "ns3/core-module.h"
@@ -35,100 +90,219 @@
 #include "ns3/network-module.h"
 #include "ns3/packet-sink.h"
 #include "ns3/flow-monitor-module.h"
+#include "ns3/ipv4-global-routing-helper.h"
+#include "ns3/traffic-control-module.h"
 
 using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE ("TcpPacingExample");
 
+std::ofstream cwndStream;
+std::ofstream pacingRateStream;
+std::ofstream ssThreshStream;
+std::ofstream packetTraceStream;
+
+static void
+CwndTracer (uint32_t oldval, uint32_t newval)
+{
+  cwndStream << std::fixed << std::setprecision (6) << Simulator::Now ().GetSeconds () << std::setw (12) << newval << std::endl;
+}
+
+static void
+PacingRateTracer (DataRate oldval, DataRate newval)
+{
+  pacingRateStream << std::fixed << std::setprecision (6) << Simulator::Now ().GetSeconds () << std::setw (12) << newval.GetBitRate () / 1e6 << std::endl;
+}
+
+static void
+SsThreshTracer (uint32_t oldval, uint32_t newval)
+{
+  ssThreshStream << std::fixed << std::setprecision (6) << Simulator::Now ().GetSeconds () << std::setw (12) << newval << std::endl;
+}
+
+static void
+TxTracer (Ptr<const Packet> p, Ptr<Ipv4> ipv4, uint32_t interface)
+{
+  packetTraceStream << std::fixed << std::setprecision (6) << Simulator::Now ().GetSeconds () << " tx " << p->GetSize () << std::endl;
+}
+
+static void
+RxTracer (Ptr<const Packet> p, Ptr<Ipv4> ipv4, uint32_t interface)
+{
+  packetTraceStream << std::fixed << std::setprecision (6) << Simulator::Now ().GetSeconds () << " rx " << p->GetSize () << std::endl;
+}
+
+void
+ConnectSocketTraces (void)
+{
+  Config::ConnectWithoutContext ("/NodeList/0/$ns3::TcpL4Protocol/SocketList/0/CongestionWindow", MakeCallback (&CwndTracer));
+  Config::ConnectWithoutContext ("/NodeList/0/$ns3::TcpL4Protocol/SocketList/0/PacingRate", MakeCallback (&PacingRateTracer));
+  Config::ConnectWithoutContext ("/NodeList/0/$ns3::TcpL4Protocol/SocketList/0/SlowStartThreshold", MakeCallback (&SsThreshTracer));
+  Config::ConnectWithoutContext ("/NodeList/0/$ns3::Ipv4L3Protocol/Tx", MakeCallback (&TxTracer));
+  Config::ConnectWithoutContext ("/NodeList/0/$ns3::Ipv4L3Protocol/Rx", MakeCallback (&RxTracer));
+}
+
 int
 main (int argc, char *argv[])
 {
-
   bool tracing = false;
-  uint32_t maxBytes = 0;
-  uint32_t TCPFlows = 1;
+
+  uint32_t maxBytes = 0; // value of zero corresponds to unlimited send
+  std::string transportProtocol = "ns3::TcpNewReno";
+
+  Time simulationEndTime = Seconds (5);
+  DataRate bottleneckBandwidth ("10Mbps");  // value of x as shown in the above network topology
+  Time bottleneckDelay = MilliSeconds (40);
+  DataRate regLinkBandwidth = DataRate (4 * bottleneckBandwidth.GetBitRate ());
+  Time regLinkDelay = MilliSeconds (5);
+  DataRate maxPacingRate ("4Gbps");
+
   bool isPacingEnabled = true;
-  std::string pacingRate = "4Gbps";
-  bool isSack = false;
-  uint32_t maxPackets = 0;
+  bool useEcn = true;
+  bool useQueueDisc = true;
+  bool shouldPaceInitialWindow = true;
+
+  // Configure defaults that are not based on explicit command-line arguments
+  // They may be overridden by general attribute configuration of command line
+  Config::SetDefault ("ns3::TcpL4Protocol::SocketType", TypeIdValue (TypeId::LookupByName (transportProtocol)));
+  Config::SetDefault ("ns3::TcpSocket::InitialCwnd", UintegerValue (10));
 
   CommandLine cmd (__FILE__);
-  cmd.AddValue ("tracing", "Flag to enable/disable tracing", tracing);
-  cmd.AddValue ("maxBytes",
-                "Total number of bytes for application to send", maxBytes);
-  cmd.AddValue ("maxPackets",
-                "Total number of bytes for application to send", maxPackets);
-  cmd.AddValue ("TCPFlows", "Number of application flows between sender and receiver", TCPFlows);
-  cmd.AddValue ("Pacing", "Flag to enable/disable pacing in TCP", isPacingEnabled);
-  cmd.AddValue ("Sack", "Flag to enable/disable sack in TCP", isSack);
-  cmd.AddValue ("PacingRate", "Max Pacing Rate in bps", pacingRate);
+  cmd.AddValue ("tracing", "Flag to enable/disable Ascii and Pcap tracing", tracing);
+  cmd.AddValue ("maxBytes", "Total number of bytes for application to send", maxBytes);
+  cmd.AddValue ("isPacingEnabled", "Flag to enable/disable pacing in TCP", isPacingEnabled);
+  cmd.AddValue ("maxPacingRate", "Max Pacing Rate", maxPacingRate);
+  cmd.AddValue ("useEcn", "Flag to enable/disable ECN", useEcn);
+  cmd.AddValue ("useQueueDisc", "Flag to enable/disable queue disc on bottleneck", useQueueDisc);
+  cmd.AddValue ("shouldPaceInitialWindow", "Flag to enable/disable pacing of TCP initial window", shouldPaceInitialWindow);
+  cmd.AddValue ("simulationEndTime", "Simulation end time", simulationEndTime);
   cmd.Parse (argc, argv);
 
-  if (maxPackets != 0 )
-    {
-      maxBytes = 500 * maxPackets;
-    }
-
-  Config::SetDefault ("ns3::TcpSocketState::MaxPacingRate", StringValue (pacingRate));
+  // Configure defaults based on command-line arguments
   Config::SetDefault ("ns3::TcpSocketState::EnablePacing", BooleanValue (isPacingEnabled));
-  Config::SetDefault ("ns3::TcpSocketBase::Sack", BooleanValue (isSack));
+  Config::SetDefault ("ns3::TcpSocketState::PaceInitialWindow", BooleanValue (shouldPaceInitialWindow));
+  Config::SetDefault ("ns3::TcpSocketBase::UseEcn", (useEcn ? EnumValue (TcpSocketState::On) : EnumValue (TcpSocketState::Off)));
+  Config::SetDefault ("ns3::TcpSocketState::MaxPacingRate", DataRateValue (maxPacingRate));
 
   NS_LOG_INFO ("Create nodes.");
-  NodeContainer nodes;
-  nodes.Create (2);
+  NodeContainer c;
+  c.Create (6);
 
   NS_LOG_INFO ("Create channels.");
-  PointToPointHelper pointToPoint;
-  pointToPoint.SetDeviceAttribute ("DataRate", StringValue ("40Gbps"));
-  pointToPoint.SetChannelAttribute ("Delay", StringValue ("0.01ms"));
+  NodeContainer n0n2 = NodeContainer (c.Get (0), c.Get (2));
+  NodeContainer n1n2 = NodeContainer (c.Get (1), c.Get (2));
+
+  NodeContainer n2n3 = NodeContainer (c.Get (2), c.Get (3));
 
-  NetDeviceContainer devices;
-  devices = pointToPoint.Install (nodes);
+  NodeContainer n3n4 = NodeContainer (c.Get (3), c.Get (4));
+  NodeContainer n3n5 = NodeContainer (c.Get (3), c.Get (5));
 
-  InternetStackHelper internet;
-  internet.Install (nodes);
+  //Define Node link properties
+  PointToPointHelper regLink;
+  regLink.SetDeviceAttribute ("DataRate", DataRateValue (regLinkBandwidth));
+  regLink.SetChannelAttribute ("Delay", TimeValue (regLinkDelay));
+
+  NetDeviceContainer d0d2 = regLink.Install (n0n2);
+  NetDeviceContainer d1d2 = regLink.Install (n1n2);
+  NetDeviceContainer d3d4 = regLink.Install (n3n4);
+  NetDeviceContainer d3d5 = regLink.Install (n3n5);
+
+  PointToPointHelper bottleNeckLink;
+  bottleNeckLink.SetDeviceAttribute ("DataRate", DataRateValue (bottleneckBandwidth));
+  bottleNeckLink.SetChannelAttribute ("Delay", TimeValue (bottleneckDelay));
+
+  NetDeviceContainer d2d3 = bottleNeckLink.Install (n2n3);
+
+  //Install Internet stack
+  InternetStackHelper stack;
+  stack.Install (c);
+
+  // Install traffic control
+  if (useQueueDisc)
+    {
+      TrafficControlHelper tchBottleneck;
+      tchBottleneck.SetRootQueueDisc ("ns3::FqCoDelQueueDisc");
+      tchBottleneck.Install (d2d3);
+    }
 
   NS_LOG_INFO ("Assign IP Addresses.");
   Ipv4AddressHelper ipv4;
   ipv4.SetBase ("10.1.1.0", "255.255.255.0");
-  Ipv4InterfaceContainer i = ipv4.Assign (devices);
+  Ipv4InterfaceContainer regLinkInterface0 = ipv4.Assign (d0d2);
 
-  NS_LOG_INFO ("Create Applications.");
+  ipv4.SetBase ("10.1.2.0", "255.255.255.0");
+  Ipv4InterfaceContainer regLinkInterface1 = ipv4.Assign (d1d2);
 
-  ApplicationContainer sourceApps;
-  ApplicationContainer sinkApps;
-  for (uint32_t iterator = 0; iterator < TCPFlows; iterator++)
-    {
-      uint16_t port = 10000 + iterator;
+  ipv4.SetBase ("10.1.3.0", "255.255.255.0");
+  Ipv4InterfaceContainer bottleneckInterface = ipv4.Assign (d2d3);
 
-      BulkSendHelper source  ("ns3::TcpSocketFactory",
-                              InetSocketAddress (i.GetAddress (1), port));
-      // Set the amount of data to send in bytes.  Zero is unlimited.
-      source.SetAttribute ("MaxBytes", UintegerValue (maxBytes));
-      sourceApps.Add (source.Install (nodes.Get (0)));
-
-      PacketSinkHelper sink ("ns3::TcpSocketFactory",
-                             InetSocketAddress (Ipv4Address::GetAny (), port));
-      sinkApps.Add (sink.Install (nodes.Get (1)));
-    }
+  ipv4.SetBase ("10.1.4.0", "255.255.255.0");
+  Ipv4InterfaceContainer regLinkInterface4 = ipv4.Assign (d3d4);
+
+  ipv4.SetBase ("10.1.5.0", "255.255.255.0");
+  Ipv4InterfaceContainer regLinkInterface5 = ipv4.Assign (d3d5);
+
+  Ipv4GlobalRoutingHelper::PopulateRoutingTables ();
+
+  NS_LOG_INFO ("Create Applications.");
 
-  sinkApps.Start (Seconds (0.0));
-  sinkApps.Stop (Seconds (5));
-  sourceApps.Start (Seconds (1));
-  sourceApps.Stop (Seconds (5));
+  // Two Sink Applications at n4 and n5
+  uint16_t sinkPort = 8080;
+  Address sinkAddress4 (InetSocketAddress (regLinkInterface4.GetAddress (1), sinkPort)); // interface of n4
+  Address sinkAddress5 (InetSocketAddress (regLinkInterface5.GetAddress (1), sinkPort)); // interface of n5
+  PacketSinkHelper packetSinkHelper ("ns3::TcpSocketFactory", InetSocketAddress (Ipv4Address::GetAny (), sinkPort));
+  ApplicationContainer sinkApps4 = packetSinkHelper.Install (c.Get (4)); //n4 as sink
+  ApplicationContainer sinkApps5 = packetSinkHelper.Install (c.Get (5)); //n5 as sink
+
+  sinkApps4.Start (Seconds (0));
+  sinkApps4.Stop (simulationEndTime);
+  sinkApps5.Start (Seconds (0));
+  sinkApps5.Stop (simulationEndTime);
+
+  // Randomize the start time between 0 and 1ms
+  Ptr<UniformRandomVariable> uniformRv = CreateObject<UniformRandomVariable> ();
+  uniformRv->SetStream (0);
+
+  // Two Source Applications at n0 and n1
+  BulkSendHelper source0 ("ns3::TcpSocketFactory", sinkAddress4);
+  BulkSendHelper source1 ("ns3::TcpSocketFactory", sinkAddress5);
+  // Set the amount of data to send in bytes.  Zero is unlimited.
+  source0.SetAttribute ("MaxBytes", UintegerValue (maxBytes));
+  source1.SetAttribute ("MaxBytes", UintegerValue (maxBytes));
+  ApplicationContainer sourceApps0 = source0.Install (c.Get (0));
+  ApplicationContainer sourceApps1 = source1.Install (c.Get (1));
+
+  sourceApps0.Start (MicroSeconds (uniformRv->GetInteger (0, 1000)));
+  sourceApps0.Stop (simulationEndTime);
+  sourceApps1.Start (MicroSeconds (uniformRv->GetInteger (0, 1000)));
+  sourceApps1.Stop (simulationEndTime);
 
   if (tracing)
     {
       AsciiTraceHelper ascii;
-      pointToPoint.EnableAsciiAll (ascii.CreateFileStream ("tcp-pacing.tr"));
-      pointToPoint.EnablePcapAll ("tcp-pacing", false);
+      regLink.EnableAsciiAll (ascii.CreateFileStream ("tcp-dynamic-pacing.tr"));
+      regLink.EnablePcapAll ("tcp-dynamic-pacing", false);
     }
 
+  cwndStream.open ("tcp-dynamic-pacing-cwnd.dat", std::ios::out);
+  cwndStream << "#Time(s) Congestion Window (B)" << std::endl;
+
+  pacingRateStream.open ("tcp-dynamic-pacing-pacing-rate.dat", std::ios::out);
+  pacingRateStream << "#Time(s) Pacing Rate (Mb/s)" << std::endl;
+
+  ssThreshStream.open ("tcp-dynamic-pacing-ssthresh.dat", std::ios::out);
+  ssThreshStream << "#Time(s) Slow Start threshold (B)" << std::endl;
+
+  packetTraceStream.open ("tcp-dynamic-pacing-packet-trace.dat", std::ios::out);
+  packetTraceStream << "#Time(s) tx/rx size (B)" << std::endl;
+
+  Simulator::Schedule (MicroSeconds (1001), &ConnectSocketTraces);
+
   FlowMonitorHelper flowmon;
   Ptr<FlowMonitor> monitor = flowmon.InstallAll ();
 
   NS_LOG_INFO ("Run Simulation.");
-  Simulator::Stop (Seconds (5));
+  Simulator::Stop (simulationEndTime);
   Simulator::Run ();
 
   monitor->CheckForLostPackets ();
@@ -137,19 +311,19 @@
   for (std::map<FlowId, FlowMonitor::FlowStats>::const_iterator i = stats.begin (); i != stats.end (); ++i)
     {
       Ipv4FlowClassifier::FiveTuple t = classifier->FindFlow (i->first);
-      if (t.sourceAddress == "10.1.1.2")
-        {
-          continue;
-        }
+
       std::cout << "Flow " << i->first  << " (" << t.sourceAddress << " -> " << t.destinationAddress << ")\n";
       std::cout << "  Tx Packets: " << i->second.txPackets << "\n";
       std::cout << "  Tx Bytes:   " << i->second.txBytes << "\n";
-      std::cout << "  TxOffered:  " << i->second.txBytes * 8.0 / 9.0 / 1000 / 1000  << " Mbps\n";
+      std::cout << "  TxOffered:  " << i->second.txBytes * 8.0 / simulationEndTime.GetSeconds () / 1000 / 1000  << " Mbps\n";
       std::cout << "  Rx Packets: " << i->second.rxPackets << "\n";
       std::cout << "  Rx Bytes:   " << i->second.rxBytes << "\n";
-      std::cout << "  Throughput: " << i->second.rxBytes * 8.0 / 9.0 / 1000 / 1000  << " Mbps\n";
+      std::cout << "  Throughput: " << i->second.rxBytes * 8.0 / simulationEndTime.GetSeconds () / 1000 / 1000  << " Mbps\n";
     }
 
+
+  cwndStream.close ();
+  pacingRateStream.close ();
+  ssThreshStream.close ();
   Simulator::Destroy ();
-  NS_LOG_INFO ("Done.");
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/examples/tcp/tcp-variants-comparison.cc ns-3.32/examples/tcp/tcp-variants-comparison.cc
--- ns-3.31/examples/tcp/tcp-variants-comparison.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/examples/tcp/tcp-variants-comparison.cc	2020-10-06 15:35:43.000000000 -0700
@@ -227,7 +227,7 @@
 
 
   CommandLine cmd (__FILE__);
-  cmd.AddValue ("transport_prot", "Transport protocol to use: TcpNewReno, "
+  cmd.AddValue ("transport_prot", "Transport protocol to use: TcpNewReno, TcpLinuxReno, "
                 "TcpHybla, TcpHighSpeed, TcpHtcp, TcpVegas, TcpScalable, TcpVeno, "
                 "TcpBic, TcpYeah, TcpIllinois, TcpWestwood, TcpWestwoodPlus, TcpLedbat, "
 		"TcpLp, TcpDctcp", transport_prot);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/examples/tcp/wscript ns-3.32/examples/tcp/wscript
--- ns-3.31/examples/tcp/wscript	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/examples/tcp/wscript	2020-10-06 15:35:43.000000000 -0700
@@ -47,3 +47,8 @@
     obj = bld.create_ns3_program('dctcp-example',
                                  ['core', 'network', 'internet', 'point-to-point', 'applications', 'traffic-control'])
     obj.source = 'dctcp-example.cc'
+
+    obj = bld.create_ns3_program('tcp-linux-reno',
+                                 ['point-to-point', 'internet', 'applications', 'traffic-control', 'network'])
+
+    obj.source = 'tcp-linux-reno.cc'
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/examples/tutorial/seventh.cc ns-3.32/examples/tutorial/seventh.cc
--- ns-3.31/examples/tutorial/seventh.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/examples/tutorial/seventh.cc	2020-10-06 15:35:43.000000000 -0700
@@ -58,6 +58,9 @@
 // So first, we create a socket and do the trace connect on it; then we pass
 // this socket into the constructor of our simple application which we then
 // install in the source node.
+//
+// NOTE: If this example gets modified, do not forget to update the .png figure
+// in src/stats/docs/seventh-packet-byte-count.png
 // ===========================================================================
 //
 class MyApp : public Application
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/examples/wireless/examples-to-run.py ns-3.32/examples/wireless/examples-to-run.py
--- ns-3.31/examples/wireless/examples-to-run.py	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/examples/wireless/examples-to-run.py	2020-10-06 15:35:43.000000000 -0700
@@ -37,12 +37,12 @@
     ("wifi-ofdm-vht-validation", "True", "True"),
     ("wifi-ofdm-he-validation", "True", "True"),
     ("wifi-80211n-mimo --simulationTime=0.1 --step=10", "True", "True"),
-    ("wifi-ht-network --simulationTime=0.2 --frequency=5 --useRts=0 --minExpectedThroughput=5 --maxExpectedThroughput=134", "True", "True"),
-    ("wifi-ht-network --simulationTime=0.2 --frequency=5 --useRts=1 --minExpectedThroughput=5 --maxExpectedThroughput=129", "True", "True"),
+    ("wifi-ht-network --simulationTime=0.2 --frequency=5 --useRts=0 --minExpectedThroughput=5 --maxExpectedThroughput=135", "True", "True"),
+    ("wifi-ht-network --simulationTime=0.2 --frequency=5 --useRts=1 --minExpectedThroughput=5 --maxExpectedThroughput=131", "True", "True"),
     ("wifi-ht-network --simulationTime=0.2 --frequency=2.4 --useRts=0 --minExpectedThroughput=5 --maxExpectedThroughput=132", "True", "True"),
-    ("wifi-ht-network --simulationTime=0.2 --frequency=2.4 --useRts=1 --minExpectedThroughput=5 --maxExpectedThroughput=127", "True", "True"),
+    ("wifi-ht-network --simulationTime=0.2 --frequency=2.4 --useRts=1 --minExpectedThroughput=5 --maxExpectedThroughput=128", "True", "True"),
     ("wifi-vht-network --simulationTime=0.2 --useRts=0  --minExpectedThroughput=5 --maxExpectedThroughput=562", "True", "True"),
-    ("wifi-vht-network --simulationTime=0.2 --useRts=1  --minExpectedThroughput=5 --maxExpectedThroughput=524", "True", "True"),
+    ("wifi-vht-network --simulationTime=0.2 --useRts=1  --minExpectedThroughput=5 --maxExpectedThroughput=525", "True", "True"),
     ("wifi-he-network --simulationTime=0.25 --frequency=5 --useRts=0 --minExpectedThroughput=6 --maxExpectedThroughput=844", "True", "True"),
     ("wifi-he-network --simulationTime=0.3 --frequency=5 --useRts=0 --useExtendedBlockAck=1 --minExpectedThroughput=6 --maxExpectedThroughput=1033", "True", "True"),
     ("wifi-he-network --simulationTime=0.3 --frequency=5 --useRts=1 --minExpectedThroughput=6 --maxExpectedThroughput=745", "True", "True"),
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/examples/wireless/wifi-80211n-mimo.cc ns-3.32/examples/wireless/wifi-80211n-mimo.cc
--- ns-3.31/examples/wireless/wifi-80211n-mimo.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/examples/wireless/wifi-80211n-mimo.cc	2020-10-06 15:35:43.000000000 -0700
@@ -146,11 +146,11 @@
           WifiHelper wifi;
           if (frequency == 5.0)
             {
-              wifi.SetStandard (WIFI_PHY_STANDARD_80211n_5GHZ);
+              wifi.SetStandard (WIFI_STANDARD_80211n_5GHZ);
             }
           else if (frequency == 2.4)
             {
-              wifi.SetStandard (WIFI_PHY_STANDARD_80211n_2_4GHZ);
+              wifi.SetStandard (WIFI_STANDARD_80211n_2_4GHZ);
               Config::SetDefault ("ns3::LogDistancePropagationLossModel::ReferenceLoss", DoubleValue (40.046));
             }
           else
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/examples/wireless/wifi-adhoc.cc ns-3.32/examples/wireless/wifi-adhoc.cc
--- ns-3.31/examples/wireless/wifi-adhoc.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/examples/wireless/wifi-adhoc.cc	2020-10-06 15:35:43.000000000 -0700
@@ -174,7 +174,7 @@
 
   Experiment experiment;
   WifiHelper wifi;
-  wifi.SetStandard (WIFI_PHY_STANDARD_80211a);
+  wifi.SetStandard (WIFI_STANDARD_80211a);
   WifiMacHelper wifiMac;
   YansWifiPhyHelper wifiPhy = YansWifiPhyHelper::Default ();
   YansWifiChannelHelper wifiChannel = YansWifiChannelHelper::Default ();
@@ -241,7 +241,7 @@
   gnuplot.GenerateOutput (std::cout);
 
   gnuplot = Gnuplot ("rate-control.png");
-  wifi.SetStandard (WIFI_PHY_STANDARD_holland);
+  wifi.SetStandard (WIFI_STANDARD_holland);
 
   NS_LOG_DEBUG ("arf");
   experiment = Experiment ("arf");
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/examples/wireless/wifi-aggregation.cc ns-3.32/examples/wireless/wifi-aggregation.cc
--- ns-3.31/examples/wireless/wifi-aggregation.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/examples/wireless/wifi-aggregation.cc	2020-10-06 15:35:43.000000000 -0700
@@ -103,7 +103,7 @@
   phy.SetChannel (channel.Create ());
 
   WifiHelper wifi;
-  wifi.SetStandard (WIFI_PHY_STANDARD_80211n_5GHZ);
+  wifi.SetStandard (WIFI_STANDARD_80211n_5GHZ);
   wifi.SetRemoteStationManager ("ns3::ConstantRateWifiManager", "DataMode", StringValue ("HtMcs7"), "ControlMode", StringValue ("HtMcs0"));
   WifiMacHelper mac;
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/examples/wireless/wifi-backward-compatibility.cc ns-3.32/examples/wireless/wifi-backward-compatibility.cc
--- ns-3.31/examples/wireless/wifi-backward-compatibility.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/examples/wireless/wifi-backward-compatibility.cc	2020-10-06 15:35:43.000000000 -0700
@@ -47,48 +47,48 @@
 
 NS_LOG_COMPONENT_DEFINE ("wifi-backward-compatibility");
 
-WifiPhyStandard ConvertStringToStandard (std::string version)
+WifiStandard ConvertStringToStandard (std::string version)
 {
-  WifiPhyStandard standard;
+  WifiStandard standard = WIFI_STANDARD_80211a;
   if (version == "80211a")
     {
-      standard = WIFI_PHY_STANDARD_80211a;
+      standard = WIFI_STANDARD_80211a;
     }
   else if (version == "80211b")
     {
-      standard = WIFI_PHY_STANDARD_80211b;
+      standard = WIFI_STANDARD_80211b;
     }
   else if (version == "80211g")
     {
-      standard = WIFI_PHY_STANDARD_80211g;
+      standard = WIFI_STANDARD_80211g;
     }
-  else if (version == "80211_10MHZ")
+  else if (version == "80211p")
     {
-      standard = WIFI_PHY_STANDARD_80211_10MHZ;
-    }
-  else if (version == "80211_5MHZ")
-    {
-      standard = WIFI_PHY_STANDARD_80211_5MHZ;
+      standard = WIFI_STANDARD_80211p;
     }
   else if (version == "holland")
     {
-      standard = WIFI_PHY_STANDARD_holland;
+      standard = WIFI_STANDARD_holland;
     }
   else if (version == "80211n_2_4GHZ")
     {
-      standard = WIFI_PHY_STANDARD_80211n_2_4GHZ;
+      standard = WIFI_STANDARD_80211n_2_4GHZ;
     }
   else if (version == "80211n_5GHZ")
     {
-      standard = WIFI_PHY_STANDARD_80211n_5GHZ;
+      standard = WIFI_STANDARD_80211n_5GHZ;
     }
   else if (version == "80211ac")
     {
-      standard = WIFI_PHY_STANDARD_80211ac;
+      standard = WIFI_STANDARD_80211ac;
+    }
+  else if (version == "80211ax_2_4GHZ")
+    {
+      standard = WIFI_STANDARD_80211ax_2_4GHZ;
     }
-  else
+  else if (version == "80211ax_5GHZ")
     {
-      standard = WIFI_PHY_STANDARD_UNSPECIFIED;
+      standard = WIFI_STANDARD_80211ax_5GHZ;
     }
   return standard;
 }
@@ -106,8 +106,8 @@
 
   CommandLine cmd (__FILE__);
   cmd.AddValue ("simulationTime", "Simulation time in seconds", simulationTime);
-  cmd.AddValue ("apVersion", "The standard version used by the AP: 80211a, 80211b, 80211g, 80211_10MHZ, 80211_5MHZ, holland, 80211n_2_4GHZ, 80211n_5GHZ or 80211ac", apVersion);
-  cmd.AddValue ("staVersion", "The standard version used by the station: 80211a, 80211b, 80211g, 80211_10MHZ, 80211_5MHZ, holland, 80211n_2_4GHZ, 80211n_5GHZ or 80211ac", staVersion);
+  cmd.AddValue ("apVersion", "The standard version used by the AP: 80211a, 80211b, 80211g, 80211p, holland, 80211n_2_4GHZ, 80211n_5GHZ, 80211ac, 80211ax_2_4GHZ or 80211ax_5GHZ", apVersion);
+  cmd.AddValue ("staVersion", "The standard version used by the station: 80211a, 80211b, 80211g, 80211_10MHZ, 80211_5MHZ, holland, 80211n_2_4GHZ, 80211n_5GHZ, 80211ac, 80211ax_2_4GHZ or 80211ax_5GHZ", staVersion);
   cmd.AddValue ("apRaa", "Rate adaptation algorithm used by the AP", apRaa);
   cmd.AddValue ("staRaa", "Rate adaptation algorithm used by the station", staRaa);
   cmd.AddValue ("apHasTraffic", "Enable/disable traffic on the AP", apHasTraffic);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/examples/wireless/wifi-clear-channel-cmu.cc ns-3.32/examples/wireless/wifi-clear-channel-cmu.cc
--- ns-3.31/examples/wireless/wifi-clear-channel-cmu.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/examples/wireless/wifi-clear-channel-cmu.cc	2020-10-06 15:35:43.000000000 -0700
@@ -191,7 +191,7 @@
           dataset.SetStyle (Gnuplot2dDataset::LINES);
 
           WifiHelper wifi;
-          wifi.SetStandard (WIFI_PHY_STANDARD_80211b);
+          wifi.SetStandard (WIFI_STANDARD_80211b);
           WifiMacHelper wifiMac;
           Config::SetDefault ("ns3::WifiRemoteStationManager::NonUnicastMode",
                               StringValue (modes[i]));
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/examples/wireless/wifi-he-network.cc ns-3.32/examples/wireless/wifi-he-network.cc
--- ns-3.31/examples/wireless/wifi-he-network.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/examples/wireless/wifi-he-network.cc	2020-10-06 15:35:43.000000000 -0700
@@ -64,13 +64,13 @@
   bool useExtendedBlockAck = false;
   double simulationTime = 10; //seconds
   double distance = 1.0; //meters
-  double frequency = 5.0; //whether 2.4 or 5.0 GHz
+  double frequency = 5; //whether 2.4, 5 or 6 GHz
   int mcs = -1; // -1 indicates an unset value
   double minExpectedThroughput = 0;
   double maxExpectedThroughput = 0;
 
   CommandLine cmd (__FILE__);
-  cmd.AddValue ("frequency", "Whether working in the 2.4 or 5.0 GHz band (other values gets rejected)", frequency);
+  cmd.AddValue ("frequency", "Whether working in the 2.4, 5 or 6 GHz band (other values gets rejected)", frequency);
   cmd.AddValue ("distance", "Distance in meters between the station and the access point", distance);
   cmd.AddValue ("simulationTime", "Simulation time in seconds", simulationTime);
   cmd.AddValue ("udp", "UDP if set to 1, TCP otherwise", udp);
@@ -130,14 +130,19 @@
 
               WifiMacHelper mac;
               WifiHelper wifi;
-              if (frequency == 5.0)
+              if (frequency == 6)
                 {
-                  wifi.SetStandard (WIFI_PHY_STANDARD_80211ax_5GHZ);
+                  wifi.SetStandard (WIFI_STANDARD_80211ax_6GHZ);
+                  Config::SetDefault ("ns3::LogDistancePropagationLossModel::ReferenceLoss", DoubleValue (48));
+                }
+              else if (frequency == 5)
+                {
+                  wifi.SetStandard (WIFI_STANDARD_80211ax_5GHZ);
                 }
               else if (frequency == 2.4)
                 {
-                  wifi.SetStandard (WIFI_PHY_STANDARD_80211ax_2_4GHZ);
-                  Config::SetDefault ("ns3::LogDistancePropagationLossModel::ReferenceLoss", DoubleValue (40.046));
+                  wifi.SetStandard (WIFI_STANDARD_80211ax_2_4GHZ);
+                  Config::SetDefault ("ns3::LogDistancePropagationLossModel::ReferenceLoss", DoubleValue (40));
                 }
               else
                 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/examples/wireless/wifi-hidden-terminal.cc ns-3.32/examples/wireless/wifi-hidden-terminal.cc
--- ns-3.31/examples/wireless/wifi-hidden-terminal.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/examples/wireless/wifi-hidden-terminal.cc	2020-10-06 15:35:43.000000000 -0700
@@ -77,7 +77,7 @@
 
   // 5. Install wireless devices
   WifiHelper wifi;
-  wifi.SetStandard (WIFI_PHY_STANDARD_80211b);
+  wifi.SetStandard (WIFI_STANDARD_80211b);
   wifi.SetRemoteStationManager ("ns3::" + wifiManager + "WifiManager");
   YansWifiPhyHelper wifiPhy =  YansWifiPhyHelper::Default ();
   wifiPhy.SetChannel (wifiChannel);
